angular
  .module \app
  .directive do
    * \ablGalleryActivity
    GalleryActivityDirective
             
function GalleryActivityDirective $window, $timeout, debug
  directive =
    restrict: \E 
    replace: false
    scope:
      * images:'='
        timeslots:'='
    template-url: \gallery-activity
    controller: controller
    link: link
      
  !function controller $scope, $timeout
    vm = this
    $scope.currentIndex = 0
    vm.goPrev = goPrev
    vm.goNext = goNext
    vm.goIndex = goIndex
    lowestPriceByActivity = (data) ->
      notDefaultPrices = []
      defaultPrices = []
      angular.forEach data, (val1, key1) ->
        angular.forEach val1.charges, (val2, key2) ->
          notDefaultPrices.push val2.amount / 100
          defaultPrices.push val2.amount / 100 if val2.isDefault
          return
      if defaultPrices.length is 0 then notDefaultPrices else defaultPrices
    lowestPriceByEvent = (data) -> 
      notDefaultPrices = []
      defaultPrices = []
      if data
        angular.forEach data.charges, (val1, key1) ->
          notDefaultPrices.push val1.amount / 100
          defaultPrices.push val1.amount / 100 if val1.isDefault
          return
      if defaultPrices.length is 0 then notDefaultPrices else defaultPrices
    $scope.$watch ((scope) ->
      $scope.timeslots), (newValue, oldValue) ->
      filterOld = (timeslots) ->
          return (timeslots || []).filter (timeslot) ->
            return moment(timeslot.endTime).isAfter(moment())
      Array.min = (array) -> Math.min.apply Math, array
      if Array.isArray $scope.timeslots then $scope.lowerPrice = Array.min lowestPriceByActivity filterOld($scope.timeslots) else $scope.lowerPrice = Array.min lowestPriceByEvent filterOld(newValue)   
      $scope.price = if isFinite($scope.lowerPrice) then $scope.lowerPrice else false
      
    function goPrev()
      if $scope.currentIndex-- is 0 then $scope.currentIndex = $scope.images.length - 1
    function goNext()
      if $scope.currentIndex++ is $scope.images.length - 1 then $scope.currentIndex = 0
    function goIndex(index)
      $scope.currentIndex = index
  !function link scope, element, attrs, controller  
    w = 0
    scope.$watch (-> scope.timeslots), ((n, o) !->
      if n
        $timeout (!-> 
          resize!
          scope.$digest()), 1000
      ), true
    angular.element($window).bind \resize, (void) !->
      resize!
      scope.$digest()
    scope.current = '0px'
    scope.goPrev = !->
      controller.goPrev()
    scope.goNext = !->
      controller.goNext()
    scope.goIndex = (index)!->
      controller.goIndex(index)
    function resize
      scope.currentIndex = 0
      w := $('.gallery-component').width()
      $('.gallery-wrapper .image').width(w)  
  directive
        